package java.awt.image;

public abstract class ColorModel {
   private int pData;
   protected int pixel_bits;
   private static ColorModel RGBdefault;

   public static ColorModel getRGBdefault() {
      if (RGBdefault == null) {
         RGBdefault = new DirectColorModel(32, 16711680, 65280, 255, -16777216);
      }

      return RGBdefault;
   }

   public ColorModel(int var1) {
      this.pixel_bits = var1;
   }

   public int getPixelSize() {
      return this.pixel_bits;
   }

   public abstract int getRed(int var1);

   public abstract int getGreen(int var1);

   public abstract int getBlue(int var1);

   public abstract int getAlpha(int var1);

   public int getRGB(int var1) {
      return this.getAlpha(var1) << 24 | this.getRed(var1) << 16 | this.getGreen(var1) << 8 | this.getBlue(var1);
   }

   private native void deletepData();

   public void finalize() {
      this.deletepData();
   }
}
